package internal

import (
	"codeup.aliyun.com/6552e56cc3b2728a4557fc18/plugin/proto"
	"context"
	"fmt"
	"github.com/carlmjohnson/requests"
	"plugins/alipay_cpn/internal/po"
)

// 插件通信信息,若不对应则会报错panic
const (
	Tag         = "union_pay_cpn"
	Version     = 1
	CookieKey   = "union_pay_cpn"
	CookieValue = "union_pay_cpn"
)

type AlipayCpnService struct{}

func (p *AlipayCpnService) Order(ctx context.Context, request *proto.OrderRequest) (*proto.OrderResponse, error) {
	conf, err := transConfig(request.Config)
	if err != nil {
		return nil, err
	}
	poReq, err := orderReq(request.Order, request.Product)
	if err != nil {
		return nil, err
	}
	param, err := paramReq(conf, poReq)
	if err != nil {
		return nil, err
	}
	uv, err := req(conf, param)
	if err != nil {
		return nil, err
	}
	var response po.OrderResp
	err = requests.URL(request.Config.BaseUri).BodyForm(uv).ToJSON(&response).Fetch(ctx)
	if err != nil {
		return nil, fmt.Errorf("请求异常，msg:" + err.Error())
	}

	return orderResp(request, response), nil
}

func (p *AlipayCpnService) Query(ctx context.Context, request *proto.QueryRequest) (*proto.QueryResponse, error) {
	return nil, nil
}

func (p *AlipayCpnService) Notify(_ context.Context, request *proto.NotifyRequest) (*proto.NotifyResponse, error) {
	return nil, nil
}
