package vo

import "codeup.aliyun.com/6552e56cc3b2728a4557fc18/plugin/proto"

type NotifyBizType string

const (
	NotifyBizTypeUse    NotifyBizType = "V_USE"
	NotifyBizTypeRefund NotifyBizType = "V_REFUND"
)

var notifyBizTypeTextMap = map[NotifyBizType]string{
	NotifyBizTypeUse:    "券核销",
	NotifyBizTypeRefund: "券退款",
}

var notifyBizTypeMap = map[NotifyBizType]proto.Status{
	NotifyBizTypeUse:    proto.Status_WRITE_OFF,
	NotifyBizTypeRefund: proto.Status_REFUND,
}

func (o NotifyBizType) GetText() string {
	msg, ok := notifyBizTypeTextMap[o]
	if !ok {
		return ""
	}
	return msg
}

func (o NotifyBizType) GetOrderStatus() proto.Status {
	if o == "" {
		return proto.Status_INVALID
	}
	if resultStatus, ok := notifyBizTypeMap[o]; ok {
		return resultStatus
	}
	return proto.Status_FAIL
}
